export class Delta {
    deltaHandler(newValue) {
        if (!newValue) {
            return;
        }
        if (newValue < 0) {
            this.deltaDisplay = (newValue * -1).toString();
            this.positive = false;
            this.positiveColorScheme = !!this.netNegative;
        }
        else {
            this.deltaDisplay = newValue.toString();
            this.positive = true;
            this.positiveColorScheme = !this.netNegative;
        }
    }
    componentWillLoad() {
        this.deltaHandler(this.delta);
    }
    componentDidLoad() {
        this.anjDeltaDidLoad.emit();
    }
    deltaDisplayString() {
        return (this.deltaDisplay === 'Infinity') ? '' : `${this.deltaDisplay}% ${this.periodFormatter(this.period)}`;
    }
    periodFormatter(period) {
        switch (period) {
            case 0:
                return 'MoM';
            case 1:
                return 'YoY';
            case 2:
                return 'WoW';
            case 3:
                return 'DoD';
            default:
                return '';
        }
    }
    hostData() {
        return {
            'class': {
                'anj-delta-negative': !this.positiveColorScheme,
                'anj-has-data': !!this.delta
            }
        };
    }
    render() {
        return (this.delta && this.deltaDisplay) ? (h("span", null,
            h("svg", { xmlns: "http://www.w3.org/2000/svg", width: "18", height: "18", viewBox: "0 0 24 24" }, this.positive ? [
                h("path", { fill: "none", d: "M0 0h24v24H0V0z" }),
                h("path", { fill: "currentColor", d: "M4 12l1.41 1.41L11 7.83V20h2V7.83l5.58 5.59L20 12l-8-8-8 8z" })
            ] : [
                h("path", { fill: "none", d: "M0 0h24v24H0V0z" }),
                h("path", { fill: "currentColor", d: "M20 12l-1.41-1.41L13 16.17V4h-2v12.17l-5.58-5.59L4 12l8 8 8-8z" })
            ]),
            this.deltaDisplayString())) : undefined;
    }
    static get is() { return "anj-delta"; }
    static get properties() { return {
        "delta": {
            "type": Number,
            "attr": "delta",
            "watchCallbacks": ["deltaHandler"]
        },
        "netNegative": {
            "type": Boolean,
            "attr": "net-negative"
        },
        "period": {
            "type": Number,
            "attr": "period"
        }
    }; }
    static get events() { return [{
            "name": "anjDeltaDidLoad",
            "method": "anjDeltaDidLoad",
            "bubbles": true,
            "cancelable": true,
            "composed": true
        }]; }
    static get style() { return "/**style-placeholder:anj-delta:**/"; }
}
